#include "AST.h"
#include "CtType.h"
#include "decls.h"


void CatchNode::emitCatchTable( ostream &os ) const
{
    ClassDecl &decl = static_cast< ClassDecl & >(*param()->dtype()->decl());
    assert( decl.category() == Decl::Class );
    
    os <<
	"(const struct class_header * const)"
	"( &" <<  decl.cDescriptorName() << " )"
	",\n";
}


const string CatchNode::emitUse( const ObjectNode & ) const
{
    // We use "param()->dtype()" instead of "caught.type()" because
    // the former is const while the later is not.
    
    // side-effect free
    return "*((" + param()->dtype()->cType() + " *) &state.value)";
}
