#define __SINST__		// g++ header bug
#include "AST.h"
#include "MethodDecl.h"
#include "code-operator.h"
#include "code.h"

TypeNode *MethodDecl::thisType() const
{
  if (modifiers() & Common::Static)
    return 0;
  else
    {
      TypeNode * const global = container()->asType();
      return (!global->isImmutable() && (type()->isLocal() || (category() & Constructor)))
	? global->addModifiers( Common::Local )
	: global;
    }
}


////////////////////////////////////////////////////////////////////////


const string MethodDecl::cMethodNameDynamic() const
{
  string result = encodedMethodName(*name(), "");

  if (category() != Constructor) {
    const TypeNode *self = thisType();
    if (self && self->isReference())
      if (methodType()->isLocalInferred())
	result = encodedMethodName(*name(), MANGLE_LQI_NAMESPACE_MARKER);
  }

  foriter (param, type()->paramTypes()->allTypes(), TreeNode::TypeIter)
    {
      if ((*param)->hasFormalSignature()) {
	result += (*param)->formalSignature();
      } else {
	if ((*param)->isLocalInferred()) {
	  result += MANGLE_LQI_FORMAL_MARKER;
	}
	result += (*param)->cType();
      }
    }

  return result;
}


const string MethodDecl::cMethodNameStatic() const
{
  return cMethodNameDynamic() + MANGLE_METHOD_NAME_END_MARKER +
    container()->cType().name;
}


const string Decl::cMethodNameDynamic() const
{
    invalidOperation( "cMethodNameDynamic" );
    return "";
}


const string Decl::cMethodNameStatic() const
{
    invalidOperation( "cMethodNameStatic" );
    return "";
}


////////////////////////////////////////////////////////////////////////


MethodDecl::MethodDecl( const string *name, TypeNode *type,
			Category _category, ClassDecl *classOrIntf,
			Modifiers mods, TreeNode *source )
  : MemberDecl( name, type, classOrIntf, mods, source ),
    _overrides( 0 ),
    _category( _category )
{
}


MethodTypeNode *MethodDecl::methodType() const
{
  TypeNode * const result = type();
  assert( result->kind() == Common::MethodKind );
  return static_cast< MethodTypeNode * >(result);
}
