#include "AST.h"
#include "CodeContext.h"
#include "UniqueId.h"


UniqueId StatementNode::generator( "break" );


void StatementNode::emitStatement( CodeContext & )
{
    undefined( "emitStatement" );
}


void StatementNode::prepareBreak()
{
    if (!breakLabel.size())
	breakLabel = generator.next();
}


void StatementNode::unwindBreak( CodeContext &context, const TreeNode &destination )
{
    unwind( context );
    
    if (&destination == this)
	context << "goto " << breakLabel << ";" << endCline;
    else
	parent()->unwindBreak( context, destination );
}


void StatementNode::codeGen( CodeContext &context )
{
    const bool hasBreakLabel = !breakLabel.empty();

    if (hasBreakLabel) context << "{" << endCline;
    emitStatement( context );
    if (hasBreakLabel) context << breakLabel << ": ;" << endCline << "}" << endCline;
}
