#include "AST.h"
#include "CodeContext.h"


void TryStmtNode::emitStatement( CodeContext &context )
{
  context.setDebugLine(this);

    CodeContext subcontext( context );
    subcontext << "  struct ExceptionState state;" << endCline
	       << "  state.prior = STATIC_REF(exception_state);" << endCline
	       << "  state.handling = 0;" << endCline
	       << "  TO_LOCAL(state.value) = NULL;" << endCline
	       << "  STATIC_REF(exception_state) = &state;" << endCline
	       << endCline
	       << "  if (!SETJMP( state.handler )) ";
    {
	CodeContext subcontext( subcontext );
	block()->codeGen( subcontext );
    }
    catches()->codeGen( subcontext );
    emitCleanup( subcontext );
    subcontext << "if (nonNull(state.value)) toss( state.value );" << endCline;
}


void TryStmtNode::emitPopState( ostream &os ) const
{
    os << "STATIC_REF(exception_state) = state.prior; ";
}


void TryStmtNode::emitCleanup( CodeContext &context ) const
{
    emitPopState( context );
    finally()->codeGen( context );
}
