#ifndef _include_CtType_h_
#define _include_CtType_h_


#include <iosfwd>
#include <string>
#include "../using-std.h"

class CfCode;
class CfFile;
class CtRegistry;


class CtType {
public:
  const string name;
  void print( ostream & ) const;

  virtual void declare( CfFile & ) const = 0;
  virtual void define( CfFile & ) const = 0;
  virtual void elaborate() const = 0;
  
  static void elaborateAll();
    
protected:
  explicit CtType( const string & );
  ~CtType() { }

private:
  static CtRegistry *allTypes;
};


ostream & operator << ( ostream &, const CtType & );
string operator + ( const string &, const CtType & );
string & operator += ( string &, const CtType & );
bool operator < ( const CtType &, const CtType & );
bool operator == ( const CtType &, const CtType & );


#include "CtType.inlines.h"


#endif // !_include_CtType_h_


// Local Variables:
// c-file-style: "gnu"
// End:
