#include "AST.h"


TypeNode *TypeNode::deepCloneType() const
{
  TypeNode * const replacement = clone();
  replacement->_parent = 0;
  return replacement;
}



////////////////////////////////////////////////////////////////////////


TypeNode *ArrayTypeNode::deepCloneType() const
{
  TypeNode * const replacement = TypeNode::deepCloneType();
  replacement->elementType( elementType()->deepCloneType() );
  return replacement;
}


TypeNode *MethodTypeNode::deepCloneType() const
{
  TypeNode * const replacement = TypeNode::deepCloneType();
  replacement->paramTypes( paramTypes()->deepCloneTypes() );
  replacement->returnType( returnType()->deepCloneType() );
  return replacement;
}


TypeListNode *TypeListNode::deepCloneTypes() const
{
  TypeListNode * const replacement = clone();
  for (unsigned sweep = arity(); sweep--; )
    replacement->child( sweep, child( sweep )->deepCloneType() );
  return replacement;
}
