#include "AST.h"
#include "solver.h"


void TypeNode::localConservative() const
{
  if (localInferable())
    solver().conservative( *this );
}


////////////////////////////////////////////////////////////////////////


void ArrayTypeNode::localConservative() const
{
  TypeNode::localConservative();
  elementType()->localConservative();
}


void MethodTypeNode::localConservative() const
{
  TypeNode::localConservative();
  returnType()->localConservative();
  paramTypes()->localConservative();
}


void TypeListNode::localConservative() const
{
  foriter (type, allTypes(), ConstTypeIter)
    (*type)->localConservative();
}
