#include <algorithm>
#include <iostream>
#include "decls.h"
#include "enact-context.h"
#include "solution.h"
#include "stats.h"
#include "stats-map.h"


LocalStatsMap LocalEnactContext::statsMap;


LocalEnactContext::LocalEnactContext( const LocalSolution &solution )
  : solution( solution ),
    thisLocal( 0 ),
    stats( statsMap[ 0 ] )
{
}


LocalEnactContext::LocalEnactContext( const LocalEnactContext &prior, const bool &thisLocal )
  : solution( prior.solution ),
    thisLocal( &thisLocal ),
    stats( prior.stats )
{
}


LocalEnactContext::LocalEnactContext( const LocalEnactContext &prior, PackageDecl *package )
  : solution( prior.solution ),
    thisLocal( prior.thisLocal ),
    stats( statsMap[ package ] )
{
}


void LocalEnactContext::printStat( ostream &sink, PackageDecl *package, const LocalStats &stats )
{
  sink << "lqi stats: "
       << (package ? package->errorName() : "no package")
       << ": " << stats << endl;
}


void LocalEnactContext::printStats( ostream &sink )
{
  for (LocalStatsMap::const_iterator sweep = statsMap.begin();
       sweep != statsMap.end(); ++sweep)
    printStat( sink, sweep->first, sweep->second );
}
