#include "AST.h"
#include "decls.h"
#include "solver.h"


void TypeNode::localWeaklySubsumedBy( const TypeNode &greater ) const
{
  if (localInferable() && greater.localInferable())
    solver().subsumedBy( *this, greater );
}


////////////////////////////////////////////////////////////////////////


void ArrayTypeNode::localWeaklySubsumedBy( const TypeNode &greater ) const
{
  TypeNode::localWeaklySubsumedBy( greater );
  
  if (greater.isArrayType())
    elementType()->localStronglySubsumedBy( *greater.elementType() );
  else
    elementType()->localConservative();
}


void MethodTypeNode::localWeaklySubsumedBy( const TypeNode &greater ) const
{
  localIdenticalTo( greater );
}
