#ifndef _include_split_c_broadcast_h_
#define _include_split_c_broadcast_h_

#include "backend.h"
#include "bcast-common.h"


#define BROADCAST_SEND( result, type, value )		\
  do {							\
    GP_type( type ) zeroBuffer;				\
    TO_GLOBAL( zeroBuffer, 0, (type *) &BUFFER );	\
    ASSIGN_GLOBAL( zeroBuffer, (value) );		\
  } while (0)


#define BROADCAST_RECEIVE( result, type, sender )


#define BROADCAST_END( result, type, sender )				\
  do {									\
    barrier();								\
    if (sizeof( type ) <= sizeof( int )) {				\
      union {								\
	int pretend;							\
	type actual;							\
      } convert;							\
      if (MYPROC == 0) convert.actual = BUFFER;				\
      convert.pretend = all_bcast_i( convert.pretend );			\
      (result) = convert.actual;					\
    } else if (sizeof( type ) <= sizeof( double )) {			\
      union {								\
	double pretend;							\
	type actual;							\
      } convert;							\
      if (MYPROC == 0) convert.actual = BUFFER;				\
      convert.pretend = all_bcast_d( convert.pretend );			\
      (result) = convert.actual;					\
    } else {								\
      ___V_SPTR target = ___create_spread_ptr( 0, (type *) &BUFFER );	\
      all_bcast_buffer( target, sizeof( type ) );			\
      (result) = BUFFER;						\
    }									\
    CYCLE = !CYCLE;							\
  } while (0)


#endif /* !_include_split_c_broadcast_h_ */
