#include <sys/stat.h>
#include <unistd.h>
#include "native-stubs.h"
#include "native-file-utils.h"

typedef PT16RandomAccessFile2io4java GP_RandomAccessFile;
typedef PT14FileDescriptor2io4java GP_FileDesc;
typedef GP_type(GP_FileDesc) GP_GP_FileDesc;


static GP_FileDesc getFileDescriptor( GP_RandomAccessFile me )
{
  GP_GP_FileDesc field;
  GP_FileDesc fileDescriptor;

  CHECK_NULL_GLOBAL( me );

  FIELD_ADDR_GLOBAL( field, me, f2fdT16RandomAccessFile2io4java );
  DEREF_GLOBAL( fileDescriptor, field );
  return fileDescriptor;
}


void m4openPT6String4lang4javaZmT16RandomAccessFile2io4java( GP_RandomAccessFile me,
							     PT6String4lang4java name,
							     jboolean writeable )
{
  jopen( getFileDescriptor( me ), name, writeable ? O_RDWR : O_RDONLY );
}


jint m4readmT16RandomAccessFile2io4java( GP_RandomAccessFile me )
{
  return jread( getFileDescriptor( me ) );
}


jint m9readBytesPTAjbyteIImT16RandomAccessFile2io4java( GP_RandomAccessFile me,
							PTAjbyte b, jint off, jint len )
{
  return jreadBytes( getFileDescriptor( me ), b, off, len );
}


void m5writeImT16RandomAccessFile2io4java( GP_RandomAccessFile me, jint b )
{
  jwrite( getFileDescriptor( me ), b );
}


void m10writeBytesPTAjbyteIImT16RandomAccessFile2io4java( GP_RandomAccessFile me,
							  PTAjbyte b, jint off, jint len )
{
  jwriteBytes( getFileDescriptor( me ), b, off, len );
}


jlong m14getFilePointermT16RandomAccessFile2io4java( GP_RandomAccessFile me )
{
  return jseek( getFileDescriptor( me ), 0, SEEK_CUR );
}

void m4seekJmT16RandomAccessFile2io4java( GP_RandomAccessFile me, jlong pos )
{
  jseek( getFileDescriptor( me ), pos, SEEK_CUR );
}


jlong m6lengthmT16RandomAccessFile2io4java( GP_RandomAccessFile me )
{
  struct stat stats;

  if (fstat( getFd( getFileDescriptor( me ) ), &stats ) == -1)
    tossIOException();
  else
    return stats.st_size;
}


void m5closemT16RandomAccessFile2io4java( GP_RandomAccessFile me )
{
  jclose( getFileDescriptor( me ) );
}
