#ifndef _TITANIUM_H_
#define _TITANIUM_H_

#include "config.h"
#include "runtime-options.h"
#include "file-64.h"

#include <assert.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

#define initloop_head(v, temp, data, arrInit, size)	\
{							\
  int i = (size);					\
  v = (arrInit);					\
  temp = (void *) data;					\
  while (i-- > 0) {


#define initloop_tail(temp, eltType)				\
    temp = (void *) (((char *) temp) + sizeof(eltType));	\
  }								\
}

/* static headers */
#include "array-addr.h"
#include "broadcast.h"
#include "exceptions.h"
#include <gc.h>
#include "java_array.h"
#include "java_array_methods.h"
#include "java_string.h"
#include "monitor.h"
#include "native-utils.h"
#include "primitives.h"
#include "subtype.h"
#include "ti-memory.h"
#include "type_header.h"

/* generated headers */
#include "domains.h"

/* local grids */
#define _ti_READ(T, N) TI_ARRAY_READ_ ## T ## _ ## N
#define _ti_PTR(T, N) TI_ARRAY_PTR_ ## T ## _ ## N
#define _ti_WRITE(T, N) TI_ARRAY_WRITE_ ## T ## _ ## N
#define _ti_CONV(T, N) TI_ARRAY_CONV_ ## T ## _ ## N
#define _ti_DUMP(T, N) TI_ARRAY_DUMP_ ## T ## _ ## N
#define _ti_CONSTRUCT(T, N) TI_ARRAY_CONSTRUCT_ ## T ## _ ## N
#define _ti_EMPTY(T, N) TI_ARRAY_empty_ ## T ## _ ## N
#define _ti_ISNULL(T, N) TI_ARRAY_isnull_ ## T ## _ ## N

#define _ti_arraymethod_cast(T, N) TI_ARRAY_cast_ ## T ## _ ## N
#define _ti_arraymethod_domain(T, N) TI_ARRAY_domain_ ## T ## _ ## N
#define _ti_arraymethod_copy(T, N) TI_ARRAY_copy_ ## T ## _ ## N
#define _ti_arraymethod_isnull(T, N) TI_ARRAY_isnull_ ## T ## _ ## N
#define _ti_arraymethod_isLocal(T, N) TI_ARRAY_isLocal_ ## T ## _ ## N
#define _ti_arraymethod_creator(T, N) TI_ARRAY_creator_ ## T ## _ ## N
#define _ti_arraymethod_restrict(T, N) TI_ARRAY_restrict_ ## T ## _ ## N
#define _ti_arraymethod_translate(T, N) TI_ARRAY_translate_ ## T ## _ ## N
#define _ti_arraymethod_permute(T, N) TI_ARRAY_permute_ ## T ## _ ## N
#define _ti_arraymethod_inject(T, N) TI_ARRAY_inject_ ## T ## _ ## N
#define _ti_arraymethod_project(T, N) TI_ARRAY_project_ ## T ## _ ## N
#define _ti_arraymethod_exchange(T, N) TI_ARRAY_exchange_ ## T ## _ ## N
#define _ti_arraymethod_slice(T, N) TI_ARRAY_slice_ ## T ## _ ## N
#define _ti_arraymethod_broadcast(T, N) TI_ARRAY_broadcast_ ## T ## _ ## N
#define _ti_arraymethod_set(T, N) TI_ARRAY_set_ ## T ## _ ## N
#define _ti_arraymethod_empty(T, N) TI_ARRAY_empty_ ## T ## _ ## N


/* global grids */
#define _ti_global_READ(T, N) TI_GLOBAL_ARRAY_READ_ ## T ## _ ## N
#define _ti_global_PTR(T, N) TI_GLOBAL_ARRAY_PTR_ ## T ## _ ## N
#define _ti_global_WRITE(T, N) TI_GLOBAL_ARRAY_WRITE_ ## T ## _ ## N
#define _ti_global_CONV(T, N) TI_GLOBAL_ARRAY_CONV_ ## T ## _ ## N
#define _ti_global_DUMP(T, N) TI_GLOBAL_ARRAY_DUMP_ ## T ## _ ## N
#define _ti_global_CONSTRUCT(T, N) TI_GLOBAL_ARRAY_CONSTRUCT_ ## T ## _ ## N
#define _ti_global_EMPTY(T, N) TI_GLOBAL_ARRAY_empty_ ## T ## _ ## N
#define _ti_global_ISNULL(T, N) TI_GLOBAL_ARRAY_isnull_ ## T ## _ ## N

#define _ti_global_arraymethod_cast(T, N) TI_GLOBAL_ARRAY_cast_ ## T ## _ ## N
#define _ti_global_arraymethod_domain(T, N) TI_GLOBAL_ARRAY_domain_ ## T ## _ ## N
#define _ti_global_arraymethod_copy(T, N) TI_GLOBAL_ARRAY_copy_ ## T ## _ ## N
#define _ti_global_arraymethod_isLocal(T, N) TI_GLOBAL_ARRAY_isLocal_ ## T ## _ ## N
#define _ti_global_arraymethod_creator(T, N) TI_GLOBAL_ARRAY_creator_ ## T ## _ ## N
#define _ti_global_arraymethod_restrict(T, N) TI_GLOBAL_ARRAY_restrict_ ## T ## _ ## N
#define _ti_global_arraymethod_translate(T, N) TI_GLOBAL_ARRAY_translate_ ## T ## _ ## N
#define _ti_global_arraymethod_permute(T, N) TI_GLOBAL_ARRAY_permute_ ## T ## _ ## N
#define _ti_global_arraymethod_inject(T, N) TI_GLOBAL_ARRAY_inject_ ## T ## _ ## N
#define _ti_global_arraymethod_isnull(T, N) TI_GLOBAL_ARRAY_isnull_ ## T ## _ ## N
#define _ti_global_arraymethod_project(T, N) TI_GLOBAL_ARRAY_project_ ## T ## _ ## N
#define _ti_global_arraymethod_exchange(T, N) TI_GLOBAL_ARRAY_exchange_ ## T ## _ ## N
#define _ti_global_arraymethod_slice(T, N) TI_GLOBAL_ARRAY_slice_ ## T ## _ ## N
#define _ti_global_arraymethod_broadcast(T, N) TI_GLOBAL_ARRAY_broadcast_ ## T ## _ ## N
#define _ti_global_arraymethod_set(T, N) TI_GLOBAL_ARRAY_set_ ## T ## _ ## N
#define _ti_global_arraymethod_empty(T, N) TI_GLOBAL_ARRAY_empty_ ## T ## _ ## N

/* Print and string routines */
extern char *ItoString(int);
extern char *FtoString(double);
extern char *ti_strcat(char *, char *);

extern void broadcast_buf(int *d, int *s, int size, int proc);
extern void bulk_copy(void * loc, void *rem, int nelems,
		      int elem_size, int stride, int proc);
extern double Ti_all_reduce_max_d(double);
extern double Ti_all_reduce_min_d(double);
extern double Ti_all_reduce_sum_d(double);


#endif /* _TITANIUM_H_ */
