package ti.domains;

//
// =============================
// Rect Domain List and Iterator
// =============================
//

public class tiRectDomainList2 {

  public tiRectDomainList2() {
    rectDomainListHead = null;
    rectDomainListTail = null;
    numItems = 0;
  }

  public tiRectDomainList2(tiRectDomainList2 dl) {
    rectDomainListHead = null;
    rectDomainListTail = null;
    numItems = 0;
    tiRectDomainListItem2 item;
    for (item = dl.rectDomainListHead; item != null; item = item.next) {
      append(item.rectDomain);
    }
  }

  public boolean isEmpty() { return (rectDomainListHead == null); }

  public void append(tiRectDomain2 rd) {
    tiRectDomainListItem2 newItem;

    newItem = new tiRectDomainListItem2();
    newItem.rectDomain = rd;
    newItem.next = null;
    if (rectDomainListHead == null) {
      rectDomainListHead = newItem;
    } else {
      rectDomainListTail.next = newItem;
    }
    rectDomainListTail = newItem;
    numItems++;
  }

  public void append(tiDomain2 d) {
    for (tiRectDomainListIterator2 iter =
	   d.getRectangles().newIterator();
	 !iter.isEnd();
	 iter.advance()) {
      append(iter.dereference());
    }
  }

  public tiRectDomainListIterator2 newIterator() {
    return new tiRectDomainListIterator2(rectDomainListHead);
  }

  public tiRectDomain2 getSingularity() {
    if (rectDomainListHead == rectDomainListTail) {
      if (rectDomainListHead == null) {
	return new tiRectDomain2();
      } else {
	return rectDomainListHead.rectDomain;
      }
    } else {
      System.out.println("Runtime: (Internal Error) Attempted to get a singularity from a RectDomain list when none existed.");
      return new tiRectDomain2();
    }
  }

  public boolean hasSingularity() {
    return (rectDomainListHead == rectDomainListTail);
  }

  public int getNumItems() {
    return numItems;
  }

  public tiRectDomainListIterator2 newIterator(tiRectDomainListIterator2 iter) {
    return new tiRectDomainListIterator2(iter);
  }

  private tiRectDomainListItem2 rectDomainListHead;
  private tiRectDomainListItem2 rectDomainListTail;
  private int numItems;
}
